import numpy as np
import torch
from PIL import Image
import matplotlib.pyplot as plt
#from utils.txt import getText
from multi_classification_no_text import (Classification, cvtColor,
                            letterbox_image, preprocess_input)
from utils.utils import letterbox_image
import cv2
import albumentations
import os
os.environ['KMP_DUPLICATE_LIB_OK'] = 'True'
# from transformers import BertTokenizer
# token = BertTokenizer.from_pretrained('bert-base-chinese')

# --------------------------------------------#
#   测试集.txt文件路径
# --------------------------------------------#
test_path = './datasets_index/new_follow_up.txt'

# --------------------------------------------#
#   训练好的基学习器参数地址，数量与基学习器个数相当
#   软硬投票选择，默认为硬投票，改为True为软投票
#   若选择硬投票，基学习器个数尽量为奇数
# --------------------------------------------#
save_path = "F:/Pyprojects/test_result/"
breast_path_test = "F:/Pyprojects/cl/data/test.txt"

# get test dataset
with open(breast_path_test, "r", encoding='utf-8') as f:
    lines_test = f.readlines()
#make  test dataloader
test_ds = Breast_Dataset3(
        annotation_lines=np.array(lines_test),
        transform=config.val_transforms,
        train=False,
        maintain_ratio=config.MAINTAIN_RATIO)

test_loader = DataLoader(
        dataset=test_ds, batch_size=config.BATCH_SIZE, num_workers=2, shuffle=False, pin_memory=True,
        drop_last=False)

#get weighted model
model = resnet.Multimodel_no_text50(pretrained=False, num_classes=2).cuda()
optimizer = optim.Adam(model.parameters(), lr=config.LEARNING_RATE, weight_decay=config.WEIGHT_DECAY)

log_path = {}
Classifier_num = 80 # 分类器个数
#log_path[0] = './logs/ep055-loss0.139-val_loss0.629.pth'

log_path[0] = ''
log_path[1] = ''
log_path[2] = ''
log_path[3] = ''
log_path[4] = ''

# log_path[5] = './logs/Ensemble_learning/Classifier6/83.1%.pth'
# log_path[100] =

arg_pred_total_list = []   # n个分类器预测标签的集合 arg_pred_total_list[1][2]：第二个分类器预测的第三个样本的标签
pre_total_list = []        # n个分类器预测概率的集合
Soft = False
for i in range(0,Classifier_num):
    if config.LOAD_MODEL:
        print("加载好参数")
        load_checkpoint(torch.load(log_path[i]), model, optimizer, config.LEARNING_RATE)
    probs = make_prediction(model=model, loader=test_loader, save_path=save_path, acc=round(accuracy, 3),recall=round(recall, 3), output_csv="test.csv", nums=nums)
    arg_pred_total_list.append(probs)
    break  # 测试的时候使用


if __name__ =="__main__":
    grand_truth = []
    with open(test_path, "r", encoding='utf-8') as f:
        lines = f.readlines()
    for index, line in enumerate(lines):
        y = int(line.split(';')[0])
        grand_truth.append(y)
    voting_pred = []
    pred_temp = 0
    total = len(lines)
    pred_temp_total = []
    print(len(lines))
    # print(len(arg_pred_total_list[0]))
    # -------------------------------------------------------#
    #   绝对投票，某类别得票超过一半（基学习器数量的一半）则判定为该类别
    # -------------------------------------------------------#
    if Soft:
        print("执行软投票")
        for i in range(0, len(lines)):
            for j in range(0, Classifier_num):
                pred_temp += pre_total_list[j][i]
                # print(pred_temp)
            if pred_temp/Classifier_num >= 0.5:  # 对每一个分类器的输出求和再取平均
                voting_pred.append(1)
            else:
                voting_pred.append(0)
            pred_temp_total.append(pred_temp/Classifier_num)
            pred_temp = 0
        print(pred_temp_total)
    else:
        print("执行硬投票")
        '''
        if divmod(Classifier_num,2) == 0:
            print("分类器个数应为奇数")
            raise NameError '''
        temp = []
        for i in range(0,len(lines)):
            for j in range(0,Classifier_num):
                pred_temp += arg_pred_total_list[j][i]
                # print(pred_temp)

            temp.append(pred_temp)
            if pred_temp >= (Classifier_num/2):          # 直接计算每一个分类器的输出的个数
                voting_pred.append(1)
            else:
                voting_pred.append(0)
            pred_temp = 0
        # print(temp)
    # print(pred_temp_total)
    print(grand_truth)
    print(voting_pred)
    correct = 0
    for i in range(len(voting_pred)):
        correct += voting_pred[i] == grand_truth[i]
    Accuracy = correct / total
    print("accuracy = %.2f%%" % (Accuracy*100))
