import os
import numpy as np
from PIL import Image
import warnings
from multiprocessing import pool
from tqdm import tqdm
import cv2

def resize_maintain_aspect(image,desired_size):
    # add padding to maintain the aspect ratio
    old_size = image.size
    ratio = float(desired_size)/max(old_size)
    new_size = tuple([int(x * ratio) for x in old_size])
    im = image.resize(new_size,Image.ANTIALIAS) #Image.ANTIALIAS
    new_im = Image.new("RGB",(desired_size,desired_size))
    new_im.paste(im,((desired_size-new_size[0])//2,(desired_size - new_size[1])//2))
    return new_im

def visualization_image(image_path):
    image = Image.open(image_path)
    image.show()
    image_resize = image.resize([224,224],Image.ANTIALIAS)
    image_resize.show()
    new_im = resize_maintain_aspect(image,desired_size=224)
    new_im.show()