Ensemble Deep Learning in Early Lesions Like BI-RADS 3 in PyTorch Framework
====
**This is a Pytorch metacode of Use of Deep Learning–Based Ultrasound Image Analysis to Predict Early Breast Cancer in breast Lesions.** 

![Data and strategy.](fig.png)

## 1.Requirements

  * PyTorch 0.8
  * Python 3.7 or 3.8
  * Albumentations
  * Pytorch_grad_cam

## 2.Usage

```config.py```   For parameter setting and Data augmentation for images.

```dataset.py```   For constructing your all dataset class.

```preprocess_images.py```   Dataset preprocess.

```train_cross_validation.py```   Training and Five cross validation.

```test.py```   Load trained and weighted file for test the performance.

```test_cam_for.py```   Ensemble Grad-Cam implementation on testing dataset.

```utils.py```   For evaluation indicators and tools function.

```sample.py``` For negative lesions sampling in bootstrap.

```ensemble.py``` Used for ensemble learning.


## 3.Data

In order to use your own data, you have to provide txt file for training and testing.

You have a look at the `train.txt` for an example.

## 4.Models

You can choose between the following models in Nets file: 


* `ResNet`: Deep residual learning for image recognition. in Proceedings of the IEEE conference on computer vision and pattern recognition 770-778 (2016).

* `SENet`: Squeeze-and-excitation networks. in Proceedings of the IEEE conference on computer vision and pattern recognition 7132-7141 (2018).

* `VGG`: Very deep convolutional networks for large-scale image recognition. (2014).

* `EfficienNet`: Efficientnetv2: Smaller models and faster training. in International Conference on Machine Learning 10096-10106 (PMLR, 2021).

## 5.Load the pretraining weights of ultrasound datasets
You can get the weights from [https://huggingface.co/MedicalUS/EDL-BC/tree/main](https://huggingface.co/MedicalUS/EDL-BC/tree/main).
Then, this python file (```test.py```) can load the pretraining weights for your own breast ultrasound training or making a prediction. 





