import os
#import  win32com.client as wc
import time
import matplotlib
import cv2 as cv
import matplotlib.pyplot as plt
import albumentations
import docx
from docx import Document
def fine_edgs(path):
    if os.path.splitext(path)[1] =='.tif':
        font = {
            "family": "Microsoft YaHei"
        }
        matplotlib.rc("font", **font)
        img = cv.imread(path, 0)
        albumentations.RandomContrast()
        aug = albumentations.Compose([
            albumentations.RandomContrast((1, 1), always_apply=True, p=1)] )
        img = aug(image=img)['image']
        img = cv.medianBlur(img, 5)

        cv.imwrite(os.path.splitext(path)[0]+"_edg1.png",img)
        plt.imshow(img, cmap=plt.cm.gray)
        plt.show()

        # Sobel
        x = cv.Sobel(img, cv.CV_16S, 1, 0, ksize=3)
        y = cv.Sobel(img, cv.CV_16S, 0, 1, ksize=3)
        absx = cv.convertScaleAbs(x)
        absy = cv.convertScaleAbs(y)
        res = cv.addWeighted(absx, 0.5, absy, 0.5, 0)
        cv.imwrite(os.path.splitext(path)[0] + "_edg2.png", res)

        # Schaar
        x = cv.Sobel(img, cv.CV_16S, 1, 0, ksize=-5)
        y = cv.Sobel(img, cv.CV_16S, 0, 1, ksize=-5)
        absx = cv.convertScaleAbs(x)
        absy = cv.convertScaleAbs(y)
        res = cv.addWeighted(absx, 0.5, absy, 0.5, 0)
        cv.imwrite(os.path.splitext(path)[0] + "_edg3.png", res)

        # Laplacian
        res = cv.Laplacian(img, cv.CV_16S)
        res = cv.convertScaleAbs(res)
        cv.imwrite(os.path.splitext(path)[0] + "_edg4.png", res)


def doc_to_docx(path):
        if os.path.splitext(path)[1] == ".doc":
            print(os.path.splitext(path))
            word = wc.Dispatch("Word.Application")
            doc = word.Documents.Open(path)  # 目标路径下的文件
            print(os.path.splitext(path)[0])
            doc.SaveAs(os.path.splitext(path)[0].split("新建")[0]+"新建 Microsoft Office Word 文档" + ".docx", 12)  # 转化后路径下的文件
            doc.Close()
            word.Quit()
            os.remove(os.path.splitext(path)[0]+".doc")
            print("删除成功")
            time.sleep(1)

def find_file(path, ext, file_list=[]):
    dir = os.listdir(path)
    for i in dir:
        i = os.path.join(path, i)
        if os.path.isdir(i):
            find_file(i, ext, file_list)
        else:
            if ext == os.path.splitext(i)[1]:
                file_list.append(i)
    return file_list




#批量转换文件
dir_path = "G:/Multimodal_BR3_classfication/datasets_test/internal/"  # 批量转换文件夹
ext = ".docx"
i = 0
file_list = find_file(dir_path, ext)
print(file_list)
#for i in file_list:
document = Document(file_list[0])
for paragraph in document.paragraphs:
    print(paragraph.text)
    #print(i)
# for file in file_list:
#     doc_to_docx(file)
#     print(i)
#     i = i+1


#批量保存边缘检测图片
# dir_path = "E:/PyProject/Multimodal_breast_cancer_projects_pytorch/datasets_swu_3_1/"  # 批量转换文件夹
# ext = ".tif"
# i = 0
# file_list = find_file(dir_path, ext)
# #for file in file_list:
# fine_edgs("E:/PyProject/Multimodal_breast_cancer_projects_pytorch/datasets_swu_3_1/34532_20220114/FILE5_1.tif")
#     #print(i)
#     #i = i+1
